unit uTheoraLib_DLL;

interface

uses Windows, Messages, SysUtils;

//OggInfo/Comment
//DLLŐ錾Ă̂AlignႤꍇlĕĐ錾Ă
//packed record  #paragma(push,1); ɑ܂B
type
  Ttheoralib_theorainfo = packed record
    width:Integer;             //encoded frame width
    height:Integer;            //encoded frame height
    frame_width:Integer;       //display frame width
    frame_height:Integer;      //display frame height
    offset_x:Integer;          //horizontal offset of the displayed frame
    offset_y:Integer;          //vertical offset of the displayed frame
    fps_numerator:Integer;     //frame rate numerator
    fps_denominator:Integer;   //frame rate denominator
    aspect_numerator:Integer;  //pixel aspect ratio numerator
    aspect_denominator:Integer;//pixel aspect ratio denominator
    colorspace:Integer;        //colorspace                               ***enum
    target_bitrate:Integer;    //nominal bitrate in bits per second
    quality:Integer;           //Nominal quality setting, 0-63
    quick_p:Integer;           //Quick encode/decode
    //DecodeOnly
    version_major:BYTE;        //unsigned char
    version_minor:BYTE;
    version_subminor:BYTE;
    codec_setup:Pointer;       //(void*)
    //EcodeOnly
    dropframes_p:Integer;
    keyframe_auto_p:Integer;
    keyframe_frequency:Integer;
    keyframe_frequency_force:Integer;  //also used for decode init to get granpos shift correct
    keyframe_data_target_bitrate:Integer;
    keyframe_auto_threshold:Integer;
    keyframe_mindistance:Integer;
    noise_sensitivity:Integer;
    sharpness:Integer;
    pixelformat:Integer;       //chroma subsampling mode to expect         ***enum
  end;
  Ttheoralib_theoracomment = packed record
    user_comments:Pointer;     //(char**) An array of comment string vectors
    comment_lengths:^Integer;  //(int*)   An array of corresponding string vector lengths in bytes
    comments:Integer;          //         The total number of comment string vectors
    vendor:^char;              //(char*)  The vendor string identifying the encoder, null terminated
  end;
  Ttheoralib_vorbisinfo = packed record
    version:Integer;
    channels:Integer;
    rate:Integer;
    bitrate_upper:Integer;
    bitrate_nominal:Integer;
    bitrate_lower:Integer;
    bitrate_window:Integer;
    codec_setup:Pointer;       //(void*)
  end;
  Ttheoralib_vorbiscomment = packed record

    user_comments:Pointer;     //(char**) An array of comment string vectors

    comment_lengths:^Integer;  //(int*)   An array of corresponding string vector lengths in bytes
    comments:Integer;          //         The total number of comment string vectors
    vendor:^char;              //(char*)  The vendor string identifying the encoder, null terminated
  end;
  Ttheoralib_yuv_buffer = packed record
    y_width:Integer;    // Width of the Y' luminance plane
    y_height:Integer;   // Height of the luminance plane
    y_stride:Integer;   // Offset in bytes between successive rows
    uv_width:Integer;   // Width of the Cb and Cr chroma planes
    uv_height:Integer;  // Height of the chroma planes
    uv_stride:Integer;  // Offset between successive chroma rows
    y:Pointer;          //(unsigned char*) Pointer to start of luminance data
    u:Pointer;          //(unsigned char*) Pointer to start of Cb data
    v:Pointer;          //(unsigned char*) Pointer to start of Cr data
  end;
  Ptheoralib_theorainfo   =^Ttheoralib_theorainfo;
  Ptheoralib_theoracomment=^Ttheoralib_theoracomment;
  Ptheoralib_vorbisinfo   =^Ttheoralib_vorbisinfo;
  Ptheoralib_vorbiscomment=^Ttheoralib_vorbiscomment;
  Ptheoralib_yuv_buffer   =^Ttheoralib_yuv_buffer;

//R[obN֐|C^
type
  //typedef int (*TOggCallback_Read)(char *datasource, char *ptr, int offset,int size);
  Ttheoralib_cb_read = function(datasource:Pointer; destptr:Pointer; offset:Integer; size:Integer):Integer; cdecl;
  //typedef int (*TOggCallback_Size)(char *datasource);
  Ttheoralib_cb_size = function(datasource:Pointer):Integer; cdecl;
  //typedef char *(*TheoraCallback_ScanLine)(char *datasource, int y);
  Ttheoralib_cb_scanline = function(bmpsource:Pointer; y:Integer):Pointer; cdecl;
  //typedef void (*TheoraCallback_Resize)(char *datasource, int w,int h);
  Ttheoralib_cb_resize = procedure(bmpsource:Pointer; w,h:Integer); cdecl;
  //typedef int (*TheoraCallback_Decode)(char *datasource,char *sender,yuv_buffer *yuvbuf, int vrev);
  Ttheoralib_cb_decode = function(bmpsource:Pointer; sender:Pointer; yuvbuf:Ptheoralib_yuv_buffer; vrev:Integer):Integer; cdecl;

//MovieDecoder֐|C^
type
  //__declspec(dllexport) void *theoralib_m_create(void);
  Ttheoralib_m_create = function:Pointer; cdecl;
  //__declspec(dllexport) void theoralib_m_free(void *ptr);
  Ttheoralib_m_free = procedure(ptr:Pointer); cdecl;
  //__declspec(dllexport) void theoralib_m_init(void *ptr);
  Ttheoralib_m_init = procedure(ptr:Pointer); cdecl;
  //__declspec(dllexport) int theoralib_m_load(
  //  void *ptr,
  //  char *datasource,
  //  TOggCallback_Read readfunc,
  //  TOggCallback_Size sizefunc,
  //  char *bitmap,
  //  TheoraCallback_ScanLine scanlinefunc,
  //  TheoraCallback_Resize resizefunc,
  //  TheoraCallback_decode decodefunc
  //);
  Ttheoralib_m_load = function(
    ptr:Pointer;
    datasource:Pointer;
    readfunc:Ttheoralib_cb_read;
    sizefunc:Ttheoralib_cb_size;
    bmpsource:Pointer;
    scanlinefunc:Ttheoralib_cb_scanline;
    resizefunc:Ttheoralib_cb_resize;
    decodefunc:Ttheoralib_cb_decode
  ):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_m_exists(void *ptr);
  Ttheoralib_m_exists = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_m_decodeframe(void *ptr,int frameno);
  Ttheoralib_m_decodeframe = function(ptr:Pointer; frameno:Integer):Integer; cdecl;
  //__declspec(dllexport) void theoralib_m_setvrevers(void *ptr,int revers);
  Ttheoralib_m_setvrevers = procedure(ptr:Pointer; revers:Integer); cdecl;
  //__declspec(dllexport) void theoralib_m_setdecodemode(void *ptr,int mode);
  Ttheoralib_m_setdecodemode = procedure(ptr:Pointer; mode:Integer); cdecl;
  //__declspec(dllexport) int  theoralib_m_nowframe(void *ptr);
  Ttheoralib_m_nowframe = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_m_totalframe(void *ptr);
  Ttheoralib_m_totalframe = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_m_totaltime(void *ptr);
  Ttheoralib_m_totaltime = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) void *theoralib_m_info(void *ptr);
  Ttheoralib_m_info = function(ptr:Pointer):Pointer; cdecl;
  //__declspec(dllexport) void *theoralib_m_comment(void *ptr);
  Ttheoralib_m_comment = function(ptr:Pointer):Pointer; cdecl;


//WaveDecoder֐|C^
type
  //__declspec(dllexport) void *theoralib_w_create(void);
  Ttheoralib_w_create = function:Pointer; cdecl;
  //__declspec(dllexport) void theoralib_w_free(void *ptr);
  Ttheoralib_w_free = procedure(ptr:Pointer); cdecl;
  //__declspec(dllexport) void theoralib_w_init(void *ptr);
  Ttheoralib_w_init = procedure(ptr:Pointer); cdecl;
  //__declspec(dllexport) int theoralib_w_load(
  //  void *ptr,
  //  char *datasource,
  //  TOggCallback_Read readfunc,
  //  TOggCallback_Size sizefunc
  //);
  Ttheoralib_w_load = function(
    ptr:Pointer;
    datasource:Pointer;
    readfunc:Ttheoralib_cb_read;
    sizefunc:Ttheoralib_cb_size
  ):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_w_exists(void *ptr);
  Ttheoralib_w_exists = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_w_decodesample(void *ptr,char *buf,int offset,int size);
  Ttheoralib_w_decodesample = function(ptr:Pointer; buf:Pointer; offset,size:Integer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_w_nowsample(void *ptr);
  Ttheoralib_w_nowsample = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_w_totalsample(void *ptr);
  Ttheoralib_w_totalsample = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) int  theoralib_w_totaltime(void *ptr);
  Ttheoralib_w_totaltime = function(ptr:Pointer):Integer; cdecl;
  //__declspec(dllexport) void *theoralib_w_info(void *ptr);
  Ttheoralib_w_info = function(ptr:Pointer):Pointer; cdecl;
  //__declspec(dllexport) void *theoralib_w_comment(void *ptr);
  Ttheoralib_w_comment = function(ptr:Pointer):Pointer; cdecl;


//DLL
//theoralib.dll
procedure theoralib_dll_init;
function  theoralib_dll_create(const filename:String):boolean;
procedure theoralib_dll_free;
//theoralib
var
  theoralib_dll_handle:THandle;
  theoralib_m_create:Ttheoralib_m_create;
  theoralib_m_free:Ttheoralib_m_free;
  theoralib_m_init:Ttheoralib_m_init;
  theoralib_m_load:Ttheoralib_m_load;
  theoralib_m_exists:Ttheoralib_m_exists;
  theoralib_m_decodeframe:Ttheoralib_m_decodeframe;
  theoralib_m_setvrevers:Ttheoralib_m_setvrevers;
  theoralib_m_setdecodemode:Ttheoralib_m_setdecodemode;
  theoralib_m_nowframe:Ttheoralib_m_nowframe;
  theoralib_m_totalframe:Ttheoralib_m_totalframe;
  theoralib_m_totaltime:Ttheoralib_m_totaltime;
  theoralib_m_info:Ttheoralib_m_info;
  theoralib_m_comment:Ttheoralib_m_comment;
  theoralib_w_create:Ttheoralib_w_create;
  theoralib_w_free:Ttheoralib_w_free;
  theoralib_w_init:Ttheoralib_w_init;
  theoralib_w_load:Ttheoralib_w_load;
  theoralib_w_exists:Ttheoralib_w_exists;
  theoralib_w_decodesample:Ttheoralib_w_decodesample;
  theoralib_w_nowsample:Ttheoralib_w_nowsample;
  theoralib_w_totalsample:Ttheoralib_w_totalsample;
  theoralib_w_totaltime:Ttheoralib_w_totaltime;
  theoralib_w_info:Ttheoralib_w_info;
  theoralib_w_comment:Ttheoralib_w_comment;

implementation


{ TTheoraLibDLL }


procedure theoralib_dll_init;
begin
  // DLL̔j
  if (theoralib_dll_handle<>0)then FreeLibrary(theoralib_dll_handle);
  theoralib_dll_handle := 0;
end;

function  theoralib_dll_create(const filename:String):boolean;
  //vZX擾
  procedure iSetProcessAddress(var p; procname: String);
  begin
    Pointer(p) := GetProcAddress(theoralib_dll_handle,pchar(procname));
    if (Pointer(p) = nil)then
    begin
      raise ERangeError.CreateFmt('֐(%s)̏Ɏs܂',[procname]);
    end;
  end;
  //[h
  function iLoad:Boolean;
  var
    s : String;
    c : array[0..255] of char;
  begin
    RESULT := FALSE;
    //΃pX炤
    s := ExpandFileName(filename);
    //t@C`FbN
    if not(FileExists(filename))then
    begin
      raise ERangeError.CreateFmt('theoralib:w肳ꂽt@C܂(%s)',[s]);
      exit;
    end;
    // DLLĂяo
    theoralib_dll_handle := LoadLibrary(pchar(s));
    if(theoralib_dll_handle=0)then
    begin
      raise ERangeError.CreateFmt('theoralib:DLLǂݍ݂Ɏs(%s)',[s]);
      exit;
    end;
    RESULT := TRUE;
  end;
begin
  RESULT := FALSE;
  theoralib_dll_init;
  //Load
  if not(iLoad)then exit;
  //֐|C^
  try
    iSetProcessAddress(theoralib_m_create,'theoralib_m_create');
    iSetProcessAddress(theoralib_m_free,'theoralib_m_free');
    iSetProcessAddress(theoralib_m_init,'theoralib_m_init');
    iSetProcessAddress(theoralib_m_load,'theoralib_m_load');
    iSetProcessAddress(theoralib_m_exists,'theoralib_m_exists');
    iSetProcessAddress(theoralib_m_decodeframe,'theoralib_m_decodeframe');
    iSetProcessAddress(theoralib_m_setvrevers,'theoralib_m_setvrevers');
    iSetProcessAddress(theoralib_m_setdecodemode,'theoralib_m_setdecodemode');
    iSetProcessAddress(theoralib_m_nowframe,'theoralib_m_nowframe');
    iSetProcessAddress(theoralib_m_totalframe,'theoralib_m_totalframe');
    iSetProcessAddress(theoralib_m_totaltime,'theoralib_m_totaltime');
    iSetProcessAddress(theoralib_m_info,'theoralib_m_info');
    iSetProcessAddress(theoralib_m_comment,'theoralib_m_comment');
    iSetProcessAddress(theoralib_w_create,'theoralib_w_create');
    iSetProcessAddress(theoralib_w_free,'theoralib_w_free');
    iSetProcessAddress(theoralib_w_init,'theoralib_w_init');
    iSetProcessAddress(theoralib_w_load,'theoralib_w_load');
    iSetProcessAddress(theoralib_w_exists,'theoralib_w_exists');
    iSetProcessAddress(theoralib_w_decodesample,'theoralib_w_decodesample');
    iSetProcessAddress(theoralib_w_nowsample,'theoralib_w_nowsample');
    iSetProcessAddress(theoralib_w_totalsample,'theoralib_w_totalsample');
    iSetProcessAddress(theoralib_w_totaltime,'theoralib_w_totaltime');
    iSetProcessAddress(theoralib_w_info,'theoralib_w_info');
    iSetProcessAddress(theoralib_w_comment,'theoralib_w_comment');
  except
    exit;
  end;
  RESULT := TRUE;
end;

procedure theoralib_dll_free;
begin
  theoralib_dll_init;
end;

end.
